/*
 * ڵʵֶڵ
 */

package dsa;

public class BinTreeNode implements BinTreePosition {
	protected Object element;//ýڵдŵĶ
	protected BinTreePosition parent;//
	protected BinTreePosition lChild;//
	protected BinTreePosition rChild;//Һ
	protected	int size;//Ŀ
	protected int height;//߶
	protected int depth;//

/**************************** 췽 ****************************/
	public BinTreeNode()
	{ this(null, null, true, null, null); }

	public BinTreeNode(
		Object e,//ڵ
		BinTreePosition p,//ڵ
		boolean asLChild,//ǷΪڵ
		BinTreePosition l,//
		BinTreePosition r)//Һ
	{
		size = 1; height = depth = 0; parent = lChild = rChild = null;//ʼ

		element = e;//ŵĶ

	//븸׵Ĺϵ
		if (null != p)
			if (asLChild)	p.attachL(this);
			else					p.attachR(this);

	//뺢ӵĹϵ
		if (null != l)	attachL(l);
		if (null != r)	attachR(r);
	}

/**************************** Positionӿڷ ********************************/
//صǰڵдŵĶ
	public Object getElem()
	{ return element; }

//obj뵱ǰڵ㣬شǰ
	public Object setElem(Object obj)
	{ Object bak = element;	element = obj;	return bak; }

/**************************** BinTreePositionӿڷ *************************/
//жǷиףΪʹࣩ
	public boolean hasParent()
	{ return null != parent; }
//صǰڵĸڵ
	public BinTreePosition getParent()
	{ return parent; }
//õǰڵĸڵ
	public void setParent(BinTreePosition p)
	{ parent = p; }

//жǷΪҶ
	public boolean isLeaf()
	{ return !hasLChild() && !hasRChild(); }

//жǷΪӣΪʹࣩ
//ǰڵиףӣ򷵻true򣬷false
	public boolean isLChild()
	{	return (hasParent() && this == getParent().getLChild())	? true : false; }

//жǷӣΪʹࣩ
	public boolean hasLChild()
	{ return null != lChild; }
//صǰڵ
	public BinTreePosition getLChild()
	{ return lChild; }
//õǰڵӣע⣺this.lChildc.parentһΪգ
	public void setLChild(BinTreePosition c)
	{ lChild = c; }

//жǷΪҺӣΪʹࣩ
//ǰڵиףҺӣ򷵻true򣬷false
	public boolean isRChild()
	{	return (hasParent() && this == getParent().getRChild())	? true : false; }
//жǷҺӣΪʹࣩ
	public boolean hasRChild()
	{ return null != rChild; }
//صǰڵҺ
	public BinTreePosition getRChild()
	{ return rChild; }
//õǰڵҺӣע⣺this.rChildc.parentһΪգ
	public void setRChild(BinTreePosition c)
	{ rChild = c; }

//صǰڵԪصĿ
	public int getSize()
	{ return size; }
//ںӷ仯󣬸µǰڵ㼰ȵĹģ
	public void updateSize() {
		size = 1;//ǰڵ
		if (hasLChild())	size += getLChild().getSize();//Ĺģ
		if (hasRChild())	size += getRChild().getSize();//Ĺģ
		
		if (hasParent())	getParent().updateSize();//ݹ¸ȵĹģ¼
	}

//صǰڵĸ߶
	public int getHeight()
	{ return height; }
//ںӷ仯󣬸µǰڵ㼰ȵĸ߶
	public void updateHeight() {
		height = 0;//ȼûҺ
		if (hasLChild())	height = Math.max(height, 1+getLChild().getHeight());//
		if (hasRChild())	height = Math.max(height, 1+getRChild().getHeight());//Һ

		if (hasParent())	getParent().updateHeight();//ݹ¸ȵĸ߶ȼ¼
	}

//صǰڵ
	public int getDepth()
	{ return depth; }
//ڸ׷仯󣬸µǰڵ㼰
	public void updateDepth() {
		depth = hasParent() ? 1+getParent().getDepth() : 0;//ǰڵ
		
		if (hasLChild())	getLChild().updateDepth();//غ£
		if (hasRChild())	getRChild().updateDepth();//ݹظкȼ¼
	}

//Ĵҵǰڵֱǰ
	public BinTreePosition getPrev() {
	//ǿգе߼Ϊǰڵֱǰ
		if (hasLChild())	return findMaxDescendant(getLChild());
	//ˣǰڵû
		if (isRChild())	return getParent();//ǰڵҺӣ׼Ϊֱǰ
	//ˣǰڵûӣ
		BinTreePosition v = this;//ӵǰڵ
		while (v.isLChild())	v = v.getParent();//һֱ
	//ˣvûиףǸ׵Һ
		return v.getParent();
	}

//ĴҵǰڵֱӺ
	public BinTreePosition getSucc() {
	//ǿգеС߼ΪǰڵֱӺ
		if (hasRChild())	return findMinDescendant(getRChild());
	//ˣǰڵûҺ
		if (isLChild())	return getParent();//ǰڵӣ׼ΪֱӺ
	//ˣǰڵûҺӣҺ
		BinTreePosition v = this;//ӵǰڵ
		while (v.isRChild())	v = v.getParent();//Һһֱ
	//ˣvûиףǸ׵
		return v.getParent();
	}

//Ͼǰڵ丸׵ĸӹϵ
//صǰڵ
	public BinTreePosition secede() {
		if (null != parent)	{
			if (isLChild())	parent.setLChild(null);//жϸָǰڵ
			else						parent.setRChild(null);

			parent.updateSize();//µǰڵ㼰ȵĹģ
			parent.updateHeight();//µǰڵ㼰ȵĸ߶

			parent = null;//жϵǰڵָԭ׵
			updateDepth();//½ڵ㼰ڵ
		}

		return this;//صǰڵ
	}

//ڵcΪǰڵ
	public BinTreePosition attachL(BinTreePosition c) {
		if (hasLChild())	getLChild().secede();//ժǰڵԭȵ

		if (null != c) {
			c.secede();//cԭ
			lChild = c;	c.setParent(this);//ȷµĸӹϵ
			updateSize();//µǰڵ㼰ȵĹģ
			updateHeight();//µǰڵ㼰ȵĸ߶
			c.updateDepth();//cڵ
		}

		return this;
	}

//ڵcΪǰڵҺ
	public BinTreePosition attachR(BinTreePosition c) {
		if (hasRChild())	getRChild().secede();//ժǰڵԭȵҺ

		if (null != c) {
			c.secede();//cԭ
			rChild = c;	c.setParent(this);//ȷµĸӹϵ
			updateSize();//µǰڵ㼰ȵĹģ
			updateHeight();//µǰڵ㼰ȵĸ߶
			c.updateDepth();//cڵ
		}

		return this;
	}

//ǰ
	public Iterator elementsPreorder() {
		List list = new List_DLNode();
		preorder(list, this);
		return list.elements();
	}

//
	public Iterator elementsInorder() {
		List list = new List_DLNode();
		inorder(list, this);
		return list.elements();
	}

//
	public Iterator elementsPostorder() {
		List list = new List_DLNode();
		postorder(list, this);
		return list.elements();
	}

//α
	public Iterator elementsLevelorder() {
		List list = new List_DLNode();
		levelorder(list, this);
		return list.elements();
	}

/****************************  ****************************/
//vĺУҳС
	protected static BinTreePosition findMinDescendant(BinTreePosition v) {
		if (null != v)
			while (v.hasLChild())	v = v.getLChild();//vһֱ½
	//ˣvΪգû
		return v;
	}

//vĺУҳ
	protected static BinTreePosition findMaxDescendant(BinTreePosition v) {
		if (null != v)
			while (v.hasRChild()) v = v.getRChild();//vҺһֱ½
	//ˣvΪգûҺ
		return v;
	}

//ǰvΪڵģӣ
	protected static void preorder(List list, BinTreePosition v) {
		if (null == v)	return;//ݹ
		list.insertLast(v);//v
		preorder(list, v.getLChild());//
		preorder(list, v.getRChild());//
	}

//vΪڵģӣ
	protected static void inorder(List list, BinTreePosition v) {
		if (null == v)	return;//ݹ
		inorder(list, v.getLChild());//
		list.insertLast(v);//v
		inorder(list, v.getRChild());//
	}

//vΪڵģӣ
	protected static void postorder(List list, BinTreePosition v) {
		if (null == v)	return;//ݹ
		postorder(list, v.getLChild());//
		postorder(list, v.getRChild());//
		list.insertLast(v);//v
	}

//αvΪڵģӣ
	protected static void levelorder(List list, BinTreePosition v) {
		Queue_List	Q = new Queue_List();//ն
		Q.enqueue(v);//ڵ
		while (!Q.isEmpty()) {
			BinTreePosition u = (BinTreePosition) Q.dequeue();//
			list.insertLast(u);//v
			if (u.hasLChild())	Q.enqueue(u.getLChild());
			if (u.hasRChild())	Q.enqueue(u.getRChild());
		}
	}
}