/*
 * ұʵֵʵ
 */

package dsa;

public class SortedDictionary_ExtArray implements SortedDictionary {
	Vector	S;//ұ
	Comparator C;//Ƚ

//ĬϹ췽
	public SortedDictionary_ExtArray()
	{	this(new ComparatorDefault()); }

//췽
	public SortedDictionary_ExtArray(Comparator comp)
	{	S = new Vector_ExtArray();	C = comp; }

/****************************  ****************************/
//ֲ
//ֵԪصȣҲkeyԲ
//ΣҪһ
//ԣkeyշصȲȻ
	private static int binSearch(Vector s, Comparator c, Object key, int lo, int hi) {
		if (lo > hi) return lo;//ݹʧ
		
		int mi = (lo + hi)>>1;//ȡֵ
		Entry e = (Entry)s.getAtRank(mi);//еĿ
		int flag = c.compare(key, e.getKey());//ȽϹؼ
		if (flag < 0)				return binSearch(s, c, key, lo, mi-1);//ת
		else if (flag > 0)	return binSearch(s, c, key, mi+1, hi);//תҰ
		else								return mi;//
	}

/**************************** ʵADT ****************************/
//ѯʵṹǰĹģ
	public int getSize()
	{	return S.getSize(); }

//жϴʵṹǷΪ
	public boolean isEmpty()
	{ return S.isEmpty(); }

//ʵдkeyΪؼĿ򷵻еһĿ򣬷null
	public Entry find(Object key) {
		int k = binSearch(S, C, key, 0, S.getSize()-1);//ҹؼΪkeyĿ
		if (0 > k || k >= S.getSize() || (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey())))
			return null;//Ŀڣ򷵻ʧܱ־
		return (Entry) S.getAtRank(k);
	}

//ɹؼΪkeyĿɵĵ
	public Iterator findAll(Object key) {
		List L = new List_DLNode();//һL

		int k = binSearch(S, C, key, 0, S.getSize()-1);//ҹؼΪkeyĿ
		if (0 > k || k >= S.getSize() || (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey())))
			return new IteratorElement(L);//Ŀڣ򷵻ؿյ

		L.insertFirst(S.getAtRank(k));//eL
		
		int lo = k;//S[k-1]ʼ
		while (0 <= --lo) {//ǰ
			if (0 != C.compare(key, ((Entry)S.getAtRank(lo)).getKey()))	break;//ֱһеĿ
			L.insertFirst(S.getAtRank(lo));//еĿL
		}
		
		int hi = k;//S[k+1]ʼ
		while (++hi < S.getSize()) {//
			if (0 != C.compare(key, ((Entry)S.getAtRank(hi)).getKey()))	break;//ֱһеĿ
			L.insertLast(S.getAtRank(hi));//еĿL
		}

		return new IteratorElement(L);//L֮
	}

//Ŀ(key, value)ظĿ
	public Entry insert(Object key, Object value) {
		Entry e = new EntryDefault(key, value);//Ŀ

	//ʵΪգֱӲԪ
		if (S.isEmpty())	return (Entry) S.insertAtRank(0, e);

	//ֲͨңȷɲλ
	//Լ飺keySΪС󣬶
		return (Entry) S.insertAtRank(binSearch(S, C, key, 0, S.getSize()-1), e);
	}

//ʵдkeyΪؼĿժеһأ򣬷null
	public Entry remove(Object key) {
		int k = binSearch(S, C, key, 0, S.getSize()-1);//ҹؼΪkeyĿ
		if (0 > k || k >= S.getSize() || (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey())))
			return null;//Ŀڣ򷵻ʧܱ־
		return (Entry) S.removeAtRank(k);
	}

//شʵĿһ
	public Iterator entries() {
		List L = new List_DLNode();
		for (int i=0; i<S.getSize(); i++)
			L.insertLast(S.getAtRank(i));
		return new IteratorElement(L);//ֱListӿڵķԪص
	}

/**************************** ʵADT ****************************/
//ʵǿգ򷵻йؼСĿ򣬷null
	public Entry first()
	{	return (S.isEmpty()) ? null : (Entry) S.getAtRank(0); }

//ʵǿգ򷵻йؼĿ򣬷null
	public Entry last()
	{	return (S.isEmpty()) ? null : (Entry) S.getAtRank(S.getSize()-1); }

//ɹؼ벻СkeyĿǽɵĵ
	public Iterator successors(Object key) {
		List L = new List_DLNode();//һL

		int k = binSearch(S, C, key, 0, S.getSize()-1);//ҹؼΪkeyĿ
		if (0 > k || k >= S.getSize() || (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey())))
			return new IteratorElement(L);//Ŀڣ򷵻ؿյ

		while (0 <= --k)//S[k-1]ʼǰֱҪġСԪ
			if (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey()))	break;
		while (S.getSize() > ++k)//̵Ԫ
			L.insertLast(S.getAtRank(k));//L

		return new IteratorElement(L);//L֮
	}

//ɹؼ벻keyĿɵĵ
	public Iterator predecessors(Object key) {
		List L = new List_DLNode();//һL

		int k = binSearch(S, C, key, 0, S.getSize()-1);//ҹؼΪkeyĿ
		if (0 > k || k >= S.getSize() || (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey())))
			return new IteratorElement(L);//Ŀڣ򷵻ؿյ

		while (S.getSize() > ++k)//S[k-1]ʼֱҪġԪ
			if (0 != C.compare(key, ((Entry)S.getAtRank(k)).getKey()))	break;
		while (0 <= --k)//ǰԪ
			L.insertLast(S.getAtRank(k));//L

		return new IteratorElement(L);//L֮
	}
}