/*
 * չ
 * BSTree
 */

package dsa;

public class SplayTree extends BSTree implements Dictionary {
/**************************** 췽 ****************************/
	public SplayTree() { super(); }
	public SplayTree(BinTreePosition r) { super(r); }
	public SplayTree(BinTreePosition r, Comparator c) { super(r, c); }

/**************************** ʵ䷽ǸBSTree ****************************/
//ʵдkeyΪؼĿ򷵻еһĿ򣬷null
	public Entry find(Object key) {
		if (isEmpty())	return null;
		BSTreeNode u = binSearch((BSTreeNode)root, key, C);
		root = moveToRoot(u);
		return (0 == C.compare(key, u.getKey())) ? (Entry)u.getElem() : null;
	}

//Ŀ(key, value)ظĿ
	public Entry insert(Object key, Object value) {
		Entry e = super.insert(key, value);//ø෽ɲ
		root = moveToRoot(lastV);//ƽ⻯
		return e;
	}

//ʵдkeyΪؼĿժеһأ򣬷null
	public Entry remove(Object key) {
		Entry e = super.remove(key);//ø෽ɾ
		if (null != e && null != lastV)	root = moveToRoot(lastV);//ƽ⻯
		return e;
	}

/****************************  ****************************/
//ӽڵzʼ϶ƽ⻯
	protected static BinTreePosition moveToRoot(BinTreePosition z) {
		while (z.hasParent())
			if (!z.getParent().hasParent())
				if (z.isLChild())	z = zig(z);
				else							z = zag(z);
			else
				if (z.isLChild())
					if (z.getParent().isLChild())	z = zigzig(z);
					else													z = zigzag(z);
				else
					if (z.getParent().isLChild())	z = zagzig(z);
					else													z = zagzag(z);
		return z;
	}

//vΪ
//˳ʱתvʹ֮һ㣨չ
//µ
	protected static BinTreePosition zig(BinTreePosition v) {
		if (null != v && v.isLChild()) {//vиףұ
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			boolean asLChild = p.isLChild();//Ƿ游
			v.secede();//ժvpΪգ
			BinTreePosition c = v.getRChild();//vҺ
			if (null != c)	p.attachL(c.secede());//Ϊp
			p.secede();//ժ
			v.attachR(p);//pΪvҺ
			if (null != g)//游ڣvΪ亢
				if (asLChild)	g.attachL(v);
				else					g.attachR(v);
		}		
		return v;
	}

//vΪҺ
//ʱתvʹ֮һ㣨չ
//µ
	protected static BinTreePosition zag(BinTreePosition v) {
		if (null != v && v.isRChild()) {//vиףұҺ
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			boolean asLChild = p.isLChild();//Ƿ游
			v.secede();//ժvpΪգ
			BinTreePosition c = v.getLChild();//v
			if (null != c)	p.attachR(c.secede());//ΪpҺ
			p.secede();//ժ
			v.attachL(p);//pΪv
			if (null != g)//游ڣvΪ亢
				if (asLChild)	g.attachL(v);
				else					g.attachR(v);
		}
		return v;
	}

//vΪӣΪ
//˳ʱתvʹ֮㣨չ
//µ
	protected static BinTreePosition zigzig(BinTreePosition v) {
		if (null != v && v.isLChild() && v.hasParent() && v.getParent().isLChild()) {
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			BinTreePosition s = g.getParent();//游
			boolean asLChild = g.isLChild();//游Ƿ游
			g.secede();
			p.secede();
			v.secede();
			BinTreePosition c;//ʱӵƶ
			c = p.getRChild(); if (null != c)	g.attachL(c.secede());//pҺΪg
			c = v.getRChild(); if (null != c)	p.attachL(c.secede());//vҺΪp
			p.attachR(g);//gΪpҺ
			v.attachR(p);//pΪvҺ
			if (null != s)//游ڣvΪ亢
				if (asLChild)	s.attachL(v);
				else					s.attachR(v);
		}
		return v;
	}

//vΪҺӣΪҺ
//˳ʱתvʹ֮㣨չ
//µ
	protected static BinTreePosition zagzag(BinTreePosition v) {
		if (null != v && v.isRChild() && v.hasParent() && v.getParent().isRChild()) {
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			BinTreePosition s = g.getParent();//游
			boolean asLChild = g.isLChild();//游Ƿ游
			g.secede();
			p.secede();
			v.secede();
			BinTreePosition c;//ʱӵƶ
			c = p.getLChild(); if (null != c)	g.attachR(c.secede());//pΪgҺ
			c = v.getLChild(); if (null != c)	p.attachR(c.secede());//vΪpҺ
			p.attachL(g);//gΪp
			v.attachL(p);//pΪv
			if (null != s)//游ڣvΪ亢
				if (asLChild)	s.attachL(v);
				else					s.attachR(v);
		}
		return v;
	}

//vΪӣΪҺ
//˳ʱתvʹ֮㣨չ
//µ
	protected static BinTreePosition zigzag(BinTreePosition v) {
		if (null != v && v.isLChild() && v.hasParent() && v.getParent().isRChild()) {
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			BinTreePosition s = g.getParent();//游
			boolean asLChild = g.isLChild();//游Ƿ游
			g.secede();
			p.secede();
			v.secede();
			BinTreePosition c;//ʱӵƶ
			c = v.getLChild(); if (null != c)	g.attachR(c.secede());//vΪgҺ
			c = v.getRChild(); if (null != c)	p.attachL(c.secede());//vҺΪp
			v.attachL(g);//gΪv
			v.attachR(p);//pΪvҺ
			if (null != s)//游ڣvΪ亢
				if (asLChild)	s.attachL(v);
				else					s.attachR(v);
		}
		return v;
	}

//vΪҺӣΪ
//˳ʱתvʹ֮㣨չ
//µ
	protected static BinTreePosition zagzig(BinTreePosition v) {
		if (null != v && v.isRChild() && v.hasParent() && v.getParent().isLChild()) {
			BinTreePosition p = v.getParent();//
			BinTreePosition g = p.getParent();//游
			BinTreePosition s = g.getParent();//游
			boolean asLChild = g.isLChild();//游Ƿ游
			g.secede();
			p.secede();
			v.secede();
			BinTreePosition c;//ʱӵƶ
			c = v.getRChild(); if (null != c)	g.attachL(c.secede());//vҺΪg
			c = v.getLChild(); if (null != c)	p.attachR(c.secede());//vΪpҺ
			v.attachR(g);//gΪvҺ
			v.attachL(p);//pΪv
			if (null != s)//游ڣvΪ亢
				if (asLChild)	s.attachL(v);
				else					s.attachR(v);
		}
		return v;
	}
}